#ifndef IHistogramFactory_h
#define IHistogramFactory_h

#include <IHistogram1D.h>
#include <IHistogram2D.h>

class IHistogramFactory {
public:
  virtual ~IHistogramFactory() {};
public:
  // The last int = 0 is a huge concession to the oldies.
  virtual IHistogram1D* create1D(const std_string&,
				 int,double,double,
				 int = 0) = 0;
  virtual IHistogram2D* create2D(const std_string&,
				 int,double,double,
				 int,double,double,
				 int = 0) = 0;
  virtual void destroy(IHistogram*) = 0;
};

#endif




