#ifndef AIDA_ICLOUD1D_H
#define AIDA_ICLOUD1D_H

#include "ICloud.h"
#include "IHistogram1D.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ICloud1D.h,v 1.1 2001/05/01 19:01:04 duns Exp $
 */

class ICloud1D : public virtual ICloud {
        
    public:
        virtual ~ICloud1D() { };
      
        virtual bool fill(double x) = 0;
        virtual bool fill(double x, double weight) = 0;
        virtual double lowerEdge() = 0;
        virtual double upperEdge() = 0;
        virtual double value(int index) = 0;
        virtual double weight(int index) = 0;
        virtual double mean() = 0;
        virtual double rms() = 0;
        virtual void convert(int nBins, double lowerEdge, double upperEdge) = 0;
        virtual IHistogram1D* histogram() = 0;
        
};

#endif
