#ifndef AIDA_ICLOUD2D_H
#define AIDA_ICLOUD2D_H

#include "ICloud.h"
#include "IHistogram2D.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ICloud2D.h,v 1.1 2001/05/01 19:01:04 duns Exp $
 */

class ICloud2D : public virtual ICloud {
    
    public:
        virtual ~ICloud2D() { };
      
        virtual bool fill(double x, double y) = 0;
        virtual bool fill(double x, double y, double weight) = 0;
        virtual double lowerEdgeX() = 0;
        virtual double lowerEdgeY() = 0;
        virtual double upperEdgeX() = 0;
        virtual double upperEdgeY() = 0;
        virtual double valueX(int index) = 0;
        virtual double valueY(int index) = 0;
        virtual double weight(int index) = 0;
        virtual double meanX() = 0;
        virtual double meanY() = 0;
        virtual double rmsX() = 0;
        virtual double rmsY() = 0;
        virtual void convert(int nBinsX, double lowerEdgeX, double upperEdgeX,
                             int nBinsY, double lowerEdgeY, double upperEdgeY) = 0;
        virtual IHistogram2D* histogram() = 0;
};

#endif
