#ifndef AIDA_ICLOUD3D_H
#define AIDA_ICLOUD3D_H

#include "ICloud.h"
#include "IHistogram3D.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ICloud3D.h,v 1.1 2001/05/01 19:01:04 duns Exp $
 */

class ICloud3D : public virtual ICloud {

    public:
        virtual ~ICloud3D() { };
      
        virtual bool fill(double x, double y, double z) = 0;
        virtual bool fill(double x, double y, double z, double weight) = 0;
        virtual double lowerEdgeX() = 0;
        virtual double lowerEdgeY() = 0;
        virtual double lowerEdgeZ() = 0;
        virtual double upperEdgeX() = 0;
        virtual double upperEdgeY() = 0;
        virtual double upperEdgeZ() = 0;
        virtual double valueX(int index) = 0;
        virtual double valueY(int index) = 0;
        virtual double valueZ(int index) = 0;
        virtual double weight(int index) = 0;
        virtual double meanX() = 0;
        virtual double meanY() = 0;
        virtual double meanZ() = 0;
        virtual double rmsX() = 0;
        virtual double rmsY() = 0;
        virtual double rmsZ() = 0;
        virtual void convert(int nBinsX, double lowerEdgeX, double upperEdgeX,
                             int nBinsY, double lowerEdgeY, double upperEdgeY,
                             int nBinsZ, double lowerEdgeZ, double upperEdgeZ) = 0;
        virtual IHistogram3D* histogram() = 0;
};

#endif
