#ifndef AIDA_ICLOUDFACTORY_H
#define AIDA_ICLOUDFACTORY_H

#include <string>

#include "ICloud1D.h"
#include "ICloud2D.h"
#include "ICloud3D.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ICloudFactory.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */

class ICloudFactory {

    public:
        virtual ~ICloudFactory() { };
      
        virtual ICloud1D* create1D(std::string nameAndLabel) = 0;
        virtual ICloud1D* create1D(std::string name, std::string label) = 0;
        virtual ICloud1D* create1D(std::string name, std::string label, int nMax, std::string options) = 0;
        
        virtual ICloud2D* create2D(std::string nameAndLabel) = 0;
        virtual ICloud2D* create2D(std::string name, std::string label) = 0;
        virtual ICloud2D* create2D(std::string name, std::string label, int nMax, std::string options) = 0;
        
        virtual ICloud3D* create3D(std::string nameAndLabel) = 0;
        virtual ICloud3D* create3D(std::string name, std::string label) = 0;
        virtual ICloud3D* create3D(std::string name, std::string label, int nMax, std::string options) = 0;     
};

#endif
