#ifndef AIDA_IFITFUNCTION_H
#define AIDA_IFITFUNCTION_H

#include <string>
#include <vector>

#include "IFunction.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IFitFunction.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */

class IFitFunction : public virtual IFunction {

    public:
        virtual ~IFitFunction() { };
  
        virtual void setFixed(std::string name, bool state) = 0;
        virtual void setBounds(std::string name, double lower, double upper) = 0;
        virtual void clearBounds(std::string name) = 0;
        virtual void setStepSize(std::string name, double step) = 0;
        virtual double error(std::string name) = 0;
        virtual std::vector<double> errors() = 0;
        virtual double chiSquare() = 0;
        
        virtual void setErrors(std::vector<double> errors) = 0;
        virtual void setChiSquare(double chiSquare) = 0;
        virtual bool hasGradient() = 0;
        virtual std::vector<double> getGradient(std::vector<double> one, std::vector<double> orTwo) = 0;
};

#endif
