#ifndef AIDA_IFUNCTION_H
#define AIDA_IFUNCTION_H

#include <string>
#include <vector>

/**
 * @author Mark Donszelmann
 * @version $Id: IFunction.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */

class IFunction {
        
    public:
        virtual ~IFunction() { };

        virtual std::string label() = 0;
        virtual double value(std::vector<double> point) = 0;
        virtual int dimension() = 0;
        virtual std::vector<std::string> parameterNames() = 0;
        virtual std::vector<double> parameterValues() = 0;
        virtual void setParameterValue(std::string name, double value) = 0;
              
};

#endif
