#ifndef AIDA_IHISTOGRAM_H
#define AIDA_IHISTOGRAM_H

#include <string>

#include "IAnnotation.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IHistogram.h,v 1.2 2001/05/14 09:12:20 duns Exp $
 */

class IHistogram {

    public:
        virtual ~IHistogram() { };
      
        virtual std::string label() = 0;
	    virtual void setLabel(std::string label) = 0;
        virtual std::string title() = 0;
        virtual IAnnotation *annotation() = 0;
        virtual int dimension() = 0;
        virtual void reset() = 0;
        virtual int entries() = 0;
        virtual int allEntries() = 0;
        virtual int extraEntries() = 0;
        virtual double equivalentBinEntries() = 0;
        virtual double sumBinHeights() = 0;
        virtual double sumAllBinHeights() = 0;
        virtual double sumExtraBinHeights() = 0;
        virtual double minBinHeight() = 0;
        virtual double maxBinHeight() = 0;
        virtual void show() = 0;
};

#endif
