#ifndef AIDA_IHISTOGRAM1D_H
#define AIDA_IHISTOGRAM1D_H

#include "IHistogram.h"
#include "IAxis.h"
#include "IFitFunction.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IHistogram1D.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */

class IHistogram1D : public virtual IHistogram {
        
    public:
        virtual ~IHistogram1D() { };
        
        virtual void fill(double x, double weight = 1.0) = 0;
        virtual int binEntries(int index) = 0;
        virtual double binHeight(int index) = 0;
        virtual double binError(int index) = 0;
        virtual double mean() = 0;
        virtual double rms() = 0;
        virtual IAxis *axis() = 0;
        virtual int coordToIndex(double coord) = 0;
        virtual IHistogram1D *add(IHistogram1D *h) = 0;
        virtual IHistogram1D *sub(IHistogram1D *h) = 0;
        virtual IHistogram1D *mul(IHistogram1D *h) = 0;
        virtual IHistogram1D *div(IHistogram1D *h) = 0;
        virtual double fit(IFitFunction *fitFunction) = 0;
        virtual void clearFit() = 0;
};

#endif
