#ifndef AIDA_IHISTOGRAM2D_H
#define AIDA_IHISTOGRAM2D_H

#include "IHistogram.h"
#include "IHistogram1D.h"
#include "IAxis.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IHistogram2D.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */

class IHistogram2D : public virtual IHistogram {

    public:
        virtual ~IHistogram2D() { };
        
        virtual void fill(double x, double y, double weight = 1.0) = 0;
        virtual int binEntries(int indexX, int indexY) = 0;
        virtual int binEntriesX(int indexX) = 0;
        virtual int binEntriesY(int indexY) = 0;
        virtual double binHeight(int indexX, int indexY) = 0;
        virtual double binHeightX(int indexX) = 0;
        virtual double binHeightY(int indexY) = 0;
        virtual double binError(int indexX, int indexY) = 0;
        virtual double meanX() = 0;
        virtual double meanY() = 0;
        virtual double rmsX() = 0;
        virtual double rmsY() = 0;
        virtual IAxis *xAxis() = 0;
        virtual IAxis *yAxis() = 0;
        virtual int coordToIndexX(double coordX) = 0;
        virtual int coordToIndexY(double coordY) = 0;
        virtual IHistogram1D *projectionX() = 0;
        virtual IHistogram1D *projectionY() = 0;
        virtual IHistogram1D *sliceX(int indexY) = 0;
        virtual IHistogram1D *sliceY(int indexX) = 0;
        virtual IHistogram1D *sliceX(int indexY1, int indexY2) = 0;
        virtual IHistogram1D *sliceY(int indexX1, int indexX2) = 0;
        virtual IHistogram2D *add(IHistogram2D *h) = 0;
        virtual IHistogram2D *sub(IHistogram2D *h) = 0;
        virtual IHistogram2D *mul(IHistogram2D *h) = 0;
        virtual IHistogram2D *div(IHistogram2D *h) = 0;
};

#endif
