#ifndef AIDA_IHISTOGRAM3D_H
#define AIDA_IHISTOGRAM3D_H

#include "IHistogram.h"
#include "IHistogram2D.h"
#include "IAxis.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IHistogram3D.h,v 1.1 2001/05/01 19:01:05 duns Exp $
 */
 
class IHistogram3D : public virtual IHistogram {

    public:
        virtual ~IHistogram3D() { };
        
        virtual void fill(double x, double y, double z, double weight = 1.0) = 0;
        virtual int binEntries(int indexX, int indexY, int indexZ) = 0;
        virtual int binEntriesX(int indexX) = 0;
        virtual int binEntriesY(int indexY) = 0;
        virtual int binEntriesZ(int indexZ) = 0;
        virtual double binHeight(int indexX, int indexY, int indexZ) = 0;
        virtual double binHeightX(int indexX) = 0;
        virtual double binHeightY(int indexY) = 0;
        virtual double binHeightZ(int indexZ) = 0;
        virtual double binError(int indexX, int indexY, int indexZ) = 0;
        virtual double meanX() = 0;
        virtual double meanY() = 0;
        virtual double meanZ() = 0;
        virtual double rmsX() = 0;
        virtual double rmsY() = 0;
        virtual double rmsZ() = 0;
        virtual IAxis *xAxis() = 0;
        virtual IAxis *yAxis() = 0;
        virtual IAxis *zAxis() = 0;
        virtual int coordToIndexX(double coordX) = 0;
        virtual int coordToIndexY(double coordY) = 0;
        virtual int coordToIndexZ(double coordZ) = 0;
        virtual IHistogram2D *projectionXY() = 0;
        virtual IHistogram2D *projectionXZ() = 0;
        virtual IHistogram2D *projectionYZ() = 0;
        virtual IHistogram2D *sliceXY(int indexZ1, int indexZ2) = 0;
        virtual IHistogram2D *sliceXZ(int indexY1, int indexY2) = 0;
        virtual IHistogram2D *sliceYZ(int indexX1, int indexX2) = 0;
        virtual IHistogram3D *add(IHistogram3D *h) = 0;
        virtual IHistogram3D *sub(IHistogram3D *h) = 0;
        virtual IHistogram3D *mul(IHistogram3D *h) = 0;
        virtual IHistogram3D *div(IHistogram3D *h) = 0;
};

#endif
