#ifndef AIDA_IMASTERFACTORY_H
#define AIDA_IMASTERFACTORY_H

#include <string>

#include "IHistogramFactory.h"
#include "ICloudFactory.h"
#include "ITree.h"

/**
 * @author Mark Donszelmann
 * @version $Id: IMasterFactory.h,v 1.2 2001/05/14 09:12:20 duns Exp $
 */

class IMasterFactory  {
    
    public:
    	virtual ~IMasterFactory() { };

        virtual ITreeFactory* createTreeFactory() = 0;
    
        virtual IHistogramFactory* createHistogramFactory() = 0;
        virtual IHistogramFactory* createHistogramFactory(ITree* tree) = 0;
    
        virtual ICloudFactory* createCloudFactory() = 0;
        virtual ICloudFactory* createCloudFactory(ITree* tree) = 0;
};
#endif
