#ifndef AIDA_ITREE_H
#define AIDA_ITREE_H

#include <string>

#include "IManagedObject.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ITree.h,v 1.2 2001/05/14 09:12:20 duns Exp $
 */
 
class ITree {
        
    public:
        virtual ~ITree() { };
      
        virtual IManagedObject* find(std::string path) = 0;
        
        virtual void cd(std::string path) = 0;
        virtual std::string pwd() = 0;
        
//        virtual Iterator ls() = 0;
//        virtual Iterator ls(bool recursive) = 0;
//        virtual Iterator ls(std::string path) = 0;
//        virtual Iterator ls(std::string path, bool recursive) = 0;

        virtual void mkdir(std::string path) = 0;
        virtual void mkdirs(std:string path) = 0; 
        virtual void rmdir(std::string path) = 0;

        virtual void rm(std::string path) = 0;
        virtual std::string findPath(IManagedObject* object) = 0;
        virtual void mv(std::string oldPath, std::string newPath) = 0;

        virtual void commit() = 0;
        virtual void cp(std::string oldPath, std::string newPath) = 0;
        virtual void cp(std::string oldPath, std::string newPath, bool recursive) = 0;
        virtual void symlink(std::string path, std::string alias) = 0;

        virtual void mount(std::string path, ITree* tree, std::string treePath) = 0;
        virtual void unmount(std::string path) = 0;

        virtual void close() = 0;
};

#endif
