#ifndef AIDA_ITUPLE_H
#define AIDA_ITUPLE_H

#include <cstdlib>
#include <string>
#include <vector>

#include "IFilter.h"
#include "IEvaluator.h"

/**
 * @author Mark Donszelmann
 * @version $Id: ITuple.h,v 1.1 2001/05/01 19:01:06 duns Exp $
 */

class ITuple {
       
    public:
        virtual ~ITuple() { };
        
        virtual void fill(int column, double value) = 0;
        virtual void fill(int column, float value) = 0;
        virtual void fill(int column, int value) = 0;
        virtual void fill(int column, short value) = 0;
        virtual void fill(int column, long value) = 0;
        virtual void fill(int column, char value) = 0;
        virtual void fill(int column, unsigned char value) = 0;
        virtual void fill(int column, bool value) = 0;
        virtual void fill(int column, std::string value) = 0;
        virtual void fill(std::vector<double> value) = 0;
        virtual void fill(std::vector<float> value) = 0;
        
        virtual void addRow() = 0;
        virtual void reset() = 0;
        
        virtual int rows() = 0;
        virtual void start() = 0;
        virtual bool skip(int rows) = 0;
        virtual bool next() = 0;

        virtual int findColumn(std::string name) = 0;

        virtual double getDouble(int column) = 0;
        virtual float getFloat(int column) = 0;
        virtual int getInt(int column) = 0;
        virtual short getShort(int column) = 0;
        virtual long getLong(int column) = 0;
        virtual char getChar(int column) = 0;
        virtual unsigned char getByte(int column) = 0;
        virtual bool getBoolean(int column) = 0;
        virtual std::string getString(int column) = 0;
        
        virtual int columns() = 0;
        virtual std::string columnName(int column) = 0;
        virtual std::string columnType(int column) = 0;
        virtual double columnMax(int column) = 0;
        virtual double columnMin(int column) = 0;
        virtual double columnMean(int column) = 0;
        virtual double columnRms(int column) = 0;
        
        virtual void setFilter(IFilter *filter) = 0;
        virtual void addEvaluator(std::string name, std::string type, IEvaluator *evaluator) = 0;
};

#endif
