
// This file has been automatically converted from ICloud1D.java 

#ifndef AIDA_ICLOUD1D_H 
#define AIDA_ICLOUD1D_H 1

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// type ahead declarations 
class IHistogram1D;

// base class(es)  
#include "AIDA/ICloud.h"


class ICloud1D  :  virtual public ICloud {

public:

   virtual ~ICloud1D () { /* nop */; }

    /**
     * @returns false if the cloud is full. You may convert it to a histogram.
     */
   virtual bool fill ( double x ) = 0;
    
   virtual bool fill ( double x, double weight ) = 0;
    
   virtual double lowerEdge (  ) = 0;
    
   virtual double upperEdge (  ) = 0;
    
   virtual double value ( int index ) = 0;
    
   virtual double weight ( int index ) = 0;
    
   virtual double mean (  ) = 0;
    
   virtual double rms (  ) = 0;
    
   virtual void convert ( int nBins, double lowerEdge, double upperEdge ) = 0;
    
    /**     
     * @return the histogram. 
     * @throws RuntimeException if the histogram is not auto-convertible and "convert"
     * has not been called.
     */
   virtual IHistogram1D * histogram (  ) = 0;
};
#endif /* ifndef AIDA_ICLOUD1D_H */ 

