
// This file has been automatically converted from ICloudFactory.java 

#ifndef AIDA_ICLOUDFACTORY_H 
#define AIDA_ICLOUDFACTORY_H 1

/**
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// includes 
#include <string>

// type ahead declarations 
class ICloud1D;
class ICloud2D;
class ICloud3D;


class ICloudFactory  {

public:

   virtual ~ICloudFactory () { /* nop */; }

   virtual ICloud1D * create1D ( const std::string & nameAndLabel ) = 0;

   virtual ICloud1D * create1D ( const std::string & name, const std::string & label ) = 0;
                                                              
   virtual ICloud1D * create1D ( const std::string & name, const std::string & label, int nMax, const std::string & options ) = 0;
                             

   virtual ICloud2D * create2D ( const std::string & nameAndLabel ) = 0;

   virtual ICloud2D * create2D ( const std::string & name, const std::string & label ) = 0;
                                                              
   virtual ICloud2D * create2D ( const std::string & name, const std::string & label, int nMax, const std::string & options ) = 0;

                                 
   virtual ICloud3D * create3D ( const std::string & nameAndLabel ) = 0;

   virtual ICloud3D * create3D ( const std::string & name, const std::string & label ) = 0;
                                                              
   virtual ICloud3D * create3D ( const std::string & name, const std::string & label, int nMax, const std::string & options ) = 0;
};
#endif /* ifndef AIDA_ICLOUDFACTORY_H */ 

