
// This file has been automatically converted from IFitFunction.java 

#ifndef AIDA_IFITFUNCTION_H 
#define AIDA_IFITFUNCTION_H 1

/**
 * User level interface to a FitFunction.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// includes 
#include <vector>
#include <string>

// base class(es)  
#include "AIDA/IFunction.h"


class IFitFunction  :  virtual public IFunction {

public:

   virtual ~IFitFunction () { /* nop */; }

    /**
     *
     */
   virtual void setFixed ( const std::string & name, bool state ) = 0;
    
    /**
     * - NOTE you may pass Double.NEGATIVE_INFINITY or Double.POSITIVE_INFINITY
     */
   virtual void setBounds ( const std::string & name, double lower, double upper ) = 0;
    
    /**
     *
     */
   virtual void clearBounds ( const std::string & name ) = 0;
    
    /**
     *
     */
   virtual void setStepSize ( const std::string & name, double step ) = 0;
    
    /**
     *
     */
   virtual double error ( const std::string & name ) = 0;
    
    /**
     *
     */
   virtual const std::vector< double > & errors (  ) = 0;
    
    /**
     *
     */
   virtual double chiSquare (  ) = 0;

    //
    // Methods needed by fitter, but not by user
    //
    
    /**
     *
     */
   virtual void setErrors ( const std::vector< double > & errors ) = 0;
    
    /**
     *
     */
   virtual void setChiSquare ( double chiSquare ) = 0;
    
    /**
     *
     */
   virtual bool hasGradient (  ) = 0;
    
    /**
     * FIXME: We need a Fitter expert here!
     */
   virtual const std::vector< double > & getGradient ( const std::vector< double > & one, const std::vector< double > & orTwo ) = 0;
};
#endif /* ifndef AIDA_IFITFUNCTION_H */ 

