
// This file has been automatically converted from IFunction.java 

#ifndef AIDA_IFUNCTION_H 
#define AIDA_IFUNCTION_H 1

/**
 * User level interface to a Function.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// includes 
#include <vector>
#include <string>


class IFunction  {

public:

   virtual ~IFunction () { /* nop */; }
    
    /**
     * @returns label of the function
     */
   virtual const std::string & label (  ) = 0;
    
    /**
     * @param point of evaluation
     * @returns value at the given point
     *          or NaN if function is not defined at this point
     * @throws IllegalArgumentException if the length of the array is incorrect
     */
   virtual double value ( const std::vector< double > & point ) = 0;
    
    /**
     * @returns dimension of the function
     */
   virtual int dimension (  ) = 0;
    
    /**
     * @returns 
     */
   virtual const std::vector< std::string > & parameterNames (  ) = 0;
    
    /**
     * @returns 
     */
   virtual const std::vector< double > & parameterValues (  ) = 0;
    
    /**
     *
     */
   virtual void setParameterValue ( const std::string & name, double value ) = 0;
};
#endif /* ifndef AIDA_IFUNCTION_H */ 

