
// This file has been automatically converted from IHistogramFactory.java 

#ifndef AIDA_IHISTOGRAMFACTORY_H 
#define AIDA_IHISTOGRAMFACTORY_H 1

/**
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// includes 
#include <vector>
#include <string>

// type ahead declarations 
class IHistogram2D;
class IHistogram1D;
class IHistogram3D;


class IHistogramFactory  {

public:

   virtual ~IHistogramFactory () { /* nop */; }

   virtual IHistogram1D * create1D ( const std::string & nameAndLabel, int nBins, double lowerEdge, double upperEdge ) = 0;
                                 
   virtual IHistogram1D * create1D ( const std::string & name, const std::string & label, int nBins, double lowerEdge, double upperEdge ) = 0;
                                 
   virtual IHistogram1D * create1D ( const std::string & name, const std::string & label, int nBins, double lowerEdge, double upperEdge, const std::string & options ) = 0;
                                                         
   virtual IHistogram1D * create1D ( const std::string & name, const std::string & label, const std::vector< double > & binEdge, const std::string & options ) = 0;
                                                         
                                 
   virtual IHistogram2D * create2D ( const std::string & nameAndLabel, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY ) = 0;
                                 
   virtual IHistogram2D * create2D ( const std::string & name, const std::string & label, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY ) = 0;
                                 
   virtual IHistogram2D * create2D ( const std::string & name, const std::string & label, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY, const std::string & options ) = 0;

   virtual IHistogram2D * create2D ( const std::string & name, const std::string & label, const std::vector< double > & binEdgeX, const std::vector< double > & binEdgeY, const std::string & options ) = 0;

                                
   virtual IHistogram3D * create3D ( const std::string & nameAndLabel, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY, int nBinsZ, double lowerEdgeZ, double upperEdgeZ ) = 0;
                                 
   virtual IHistogram3D * create3D ( const std::string & name, const std::string & label, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY, int nBinsZ, double lowerEdgeZ, double upperEdgeZ ) = 0;
                                 
   virtual IHistogram3D * create3D ( const std::string & name, const std::string & label, int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY, int nBinsZ, double lowerEdgeZ, double upperEdgeZ, const std::string & options ) = 0;
                                
   virtual IHistogram3D * create3D ( const std::string & name, const std::string & label, const std::vector< double > & binEdgeX, const std::vector< double > & binEdgeY, const std::vector< double > & binEdgeZ, const std::string & options ) = 0;
                                
};
#endif /* ifndef AIDA_IHISTOGRAMFACTORY_H */ 

