
// This file has been automatically converted from ITuple.java 

#ifndef AIDA_ITUPLE_H 
#define AIDA_ITUPLE_H 1

/**
 * User level interface to a Tuple.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version 2.0, 06-02-2001
 */

// includes 
#include <vector>
#include <string>

// type ahead declarations 
class INtupleEntry;
class IEvaluator;
class IFilter;


class ITuple  {

public:

   virtual ~ITuple () { /* nop */; }
    
    // writing interface, always at the end
   virtual void fill ( int column, double value ) = 0;
   virtual void fill ( int column, float value ) = 0;
   virtual void fill ( int column, int value ) = 0;
   virtual void fill ( int column, short value ) = 0;
   virtual void fill ( int column, long value ) = 0;
   virtual void fill ( int column, char value ) = 0;
// unknown parameter 'byte' found:     public void fill(int column, byte value) throws IllegalArgumentException;   virtual void fill ( int column, bool value ) = 0;
   virtual void fill ( int column, const std::string & value ) = 0;
   virtual void fill ( int column, const INtupleEntry & value ) = 0;
    
   virtual void fill ( const std::vector< double > & values ) = 0;
   virtual void fill ( const std::vector< float > & values ) = 0;
    /**
     * Should be called after fill is called for the columns.
     * Unfilled columns will be filled with the default value for that column.
     */
   virtual void addRow (  ) = 0;
   virtual void reset (  ) = 0;
    
    // reading interface
    /**
     * @returns -1 if cannot be determined.
     */
   virtual int rows (  ) = 0;
    /**
     * Positions the read cursor immediately before the first row.
     */
   virtual void start (  ) = 0;
    /**
     * Skips rows.
     * @param rows number of rows to skip, greater than 0.
     * @returns false if it cannot skip rows.
     */
   virtual bool skip ( int rows ) = 0;
    /**
     * Positions the cursor at the next row.
     * @returns false if there is no next row.
     */
   virtual bool next (  ) = 0;
    /**
     * @returns the column number for a given name
     */
   virtual int findColumn ( const std::string & name ) = 0;
    
   virtual double getDouble ( int column ) = 0;
   virtual float getFloat ( int column ) = 0;
   virtual int getInt ( int column ) = 0;
   virtual short getShort ( int column ) = 0;
   virtual long getLong ( int column ) = 0;
   virtual char getChar ( int column ) = 0;
// unknown parameter 'byte' found:     public byte getByte(int column) throws ClassCastException;   virtual bool getBoolean ( int column ) = 0;
   virtual const std::string & getString ( int column ) = 0;
   virtual INtupleEntry * getObject ( int column ) = 0;
    
    // meta-info reading
   virtual int columns (  ) = 0;
   virtual const std::string & columnName ( int column ) = 0;
    // return type may have to be String
   virtual INtupleEntry * columnType ( int column ) = 0;
    // values can be approximations, or can return Double.NaN
   virtual double columnMin ( int column ) = 0;
   virtual double columnMax ( int column ) = 0;
   virtual double columnMean ( int column ) = 0;
   virtual double columnRms ( int column ) = 0;
    
   virtual void setFilter ( const IFilter & filter ) = 0;
   virtual void addEvaluator ( const std::string & name, const INtupleEntry & type, const IEvaluator & evaluator ) = 0;
};
#endif /* ifndef AIDA_ITUPLE_H */ 

