
// This file has been automatically converted from ICloud2D.java 

#ifndef AIDA_ICLOUD2D_H 
#define AIDA_ICLOUD2D_H 1

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud2D.h,v 1.5 2001/08/08 09:35:42 pfeiffer Exp $
 */

// type ahead declarations 
class IHistogram2D;

// base class(es)  
#include "AIDA/ICloud.h"


class ICloud2D  :  virtual public ICloud {

public:

   virtual ~ICloud2D () { /* nop */; }

   virtual bool fill ( double x, double y, double weight = 1. ) = 0;
    
   virtual double lowerEdgeX (  ) const = 0;
    
   virtual double lowerEdgeY (  ) const = 0;
    
   virtual double upperEdgeX (  ) const = 0;
    
   virtual double upperEdgeY (  ) const = 0;
    
   virtual double valueX ( int index ) const = 0;
   virtual double valueY ( int index ) const = 0;
   virtual double weight ( int index ) const = 0;
    
   virtual double meanX (  ) const = 0;
    
   virtual double meanY (  ) const = 0;
    
   virtual double rmsX  (  ) const = 0;
    
   virtual double rmsY  (  ) const = 0;
    
   virtual bool convert ( int nBinsX, double lowerEdgeX, double upperEdgeX, int nBinsY, double lowerEdgeY, double upperEdgeY ) = 0;
    
   virtual IHistogram2D * histogram (  ) = 0;
};
#endif /* ifndef AIDA_ICLOUD2D_H */ 

