
// This file has been automatically converted from IFunction.java 

#ifndef AIDA_IFUNCTION_H 
#define AIDA_IFUNCTION_H 1

/**
 * A function which can be dispayed on a plot or fitted to a hsitogram.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: IFunction.h,v 1.9 2001/11/29 07:38:44 barrand Exp $
 */

// includes 
#include <vector>

// base class(es)
#include "AIDA/IConstants.h"


class IFunction : virtual public IConstants  {

public:

   virtual ~IFunction () { /* nop */; }
    
    /**
     * @returns label of the function
     */
   virtual const std::string & label (  ) const = 0;
    
    /**
     * @param point of evaluation
     * @returns value at the given point
     *          or NaN if function is not defined at this point
     * @throws IllegalArgumentException if the length of the array is incorrect
     */
   virtual double value ( const std::vector< double > & point ) const = 0;

   //-FIXME: for 1-D:  operator () (double), similar for n-D
    
    /**
     * @returns dimension of the function
     */
   virtual int dimension (  ) const = 0;
    
    /**
     * @returns 
     */
   virtual const std::vector< std::string > & parameterNames (  ) const = 0;
    
    /**
     * @returns 
     */
   virtual const std::vector< double > & parameterValues (  ) const = 0;
    
    /**
     *
     */
   virtual bool setParameterValue ( const std::string & name, double value ) = 0;

};
#endif /* ifndef AIDA_IFUNCTION_H */ 

