
// This file has been automatically converted from ITreeFactory.java 

#ifndef AIDA_ITREEFACTORY_H 
#define AIDA_ITREEFACTORY_H 1


/**
 * The creator of trees.
 *
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ITreeFactory.h,v 1.4 2001/08/08 09:35:43 pfeiffer Exp $
 */

// includes 
#include <string>

// type ahead declarations 
class ITree;


class ITreeFactory  {

public:

   virtual ~ITreeFactory () { /* nop */; }
    /**
     * Creates a new tree and associates it with a store.
     * The store is assumed to be read/write.
     * The store will be created if it does not exist.
     * @param readOnly  If true the store is opened readonly, an exception if it does not exist
     * @param exists    If true the file must exist, if false the file will be created
     * @param storeName The name of the store, if empty (""), the tree is created
     *                  in memory and therefore will not be associated with a file.
     * @param storeType Implementation specific string, may control store type
     */
   virtual ITree * create ( const std::string & storeName = "", bool readOnly = false, bool exists = false, const std::string & storeType = "" ) = 0;
};
#endif /* ifndef AIDA_ITREEFACTORY_H */ 

