package hep.aida;

/**
 * User level interface to a Cloud.
 * A Cloud is an unbinned collection of points. It can be used to
 * represent scatter plots or dynamically rebinnable histograms.
 * If they number of entries in the cloud exceeds some threshold 
 * they may be automatically converted to a binned histogram.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface ICloud {

    public String label();
    
    public void setLabel(String label);
    
    public int entries();
    
    public int dimension();
    
    public double sumOfWeights();
}
