package hep.aida;

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud3D.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface ICloud3D extends ICloud {

    public boolean fill(double x, double y, double z);
    
    public boolean fill(double x, double y, double z, double weight);
    
    public double lowerEdgeX();
    
    public double lowerEdgeY();
    
    public double lowerEdgeZ();
    
    public double upperEdgeX();
    
    public double upperEdgeY();
    
    public double upperEdgeZ();
    
    public double valueX(int index);
    public double valueY(int index);
    public double valueZ(int index);
    public double weight(int index);
    
    public double meanX();
    
    public double meanY();
    
    public double meanZ();
    
    public double rmsX();

    public double rmsY();

    public double rmsZ();
    
    public void convert(int nBinsX, double lowerEdgeX, double upperEdgeX, 
                        int nBinsY, double lowerEdgeY, double upperEdgeY,
                        int nBinsZ, double lowerEdgeZ, double upperEdgeZ);
    
    public IHistogram3D histogram()throws RuntimeException;
}
