package hep.aida;

/**
 * A function which can be dispayed on a plot or fitted to a hsitogram.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: IFunction.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface IFunction {
    
    /**
     * @returns label of the function
     */
    public String label();
    
    /**
     * @param point of evaluation
     * @returns value at the given point
     *          or NaN if function is not defined at this point
     * @throws IllegalArgumentException if the length of the array is incorrect
     */
    public double value(double[] point) throws IllegalArgumentException;
    
    /**
     * @returns dimension of the function
     */
    public int dimension();
    
    /**
     * @returns 
     */
    public String[] parameterNames();
    
    /**
     * @returns 
     */
    public double[] parameterValues();
    
    /**
     *
     */
    public void setParameterValue(String name, double value);
}
