/*
 * IFunctionFactory.java
 *
 * Created on November 7, 2001, 1:57 PM
 */

package hep.aida;
import java.util.Vector;

/**
 * @author AIDA Team
 * @version $Id: IFunctionFactory.java,v 1.2 2001/11/12 09:20:05 barrand Exp $ 
 */
public interface IFunctionFactory 
{
  /**
   * @param type  A string to describe the type of the function: e.g.,
   *              "G"  or "Gaussian"    for gaussian, 
   *              "E"  or "Exponential" for exponential,
   *              "P"  or "Polynomial"  for polynomial(n) (see below for specifying the degree),
   *              "BW" or "BreitWigner" for Breit-Wigner function
   * @param parameters The parameters for the function. 
   *                   For the Polynomial the size of the vector determines the degree of it.
   * @returns the requested function.
   */
  IFunction create(String name, String label, 
			           String type, Vector parameterValues, 
			           String parameterNames);
  
  IFunction create(String name, String label, 
			           String type, Vector parameterValues);
  
  IFunction createScripted(String name, String label, String script);

  IFitFunction createFit(String name, String label,String type,String options);

}

