package hep.aida;

/**
 * A factory for creating ITuples.
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ITupleFactory.java,v 1.5 2001/07/19 23:30:52 tonyj Exp $
 */
public interface ITupleFactory {

    /**
     * Create an NTuple
     * @param name The persistency name of the n-tuple
     * @param label The label of the n-tuple
     * @param columnNames The names of the columns
     * @param columnType The types of  the columns
     * @param options NTuple options (currently undefined)
     */
    public ITuple create(String name, String label, 
                         String[] columnNames, Class[] columnType, String options);

    /**
     * Create an NTuple
     * @param name The persistency name of the n-tuple
     * @param label The label of the n-tuple
     * @param columns The names and types of the columns e.g. "float px, py, pz, float energy, int charge"
     * @param options NTuple options (currently undefined)
     */
    public ITuple create(String name, String label, String columns, String options);
}
