
// This file has been automatically converted from ICloud1D.java 

#ifndef AIDA_ICLOUD1D_H 
#define AIDA_ICLOUD1D_H 1

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud1D.h,v 1.5 2001/08/08 09:35:42 pfeiffer Exp $
 */

// type ahead declarations 
class IHistogram1D;

// base class(es)  
#include "AIDA/ICloud.h"


class ICloud1D  :  virtual public ICloud {

public:

   virtual ~ICloud1D () { /* nop */; }

    /**
     * @returns false if the cloud is full. You may convert it to a histogram.
     */
   virtual bool fill ( double x, double weight = 1. ) = 0;
    
   virtual double lowerEdge (  ) const = 0;
    
   virtual double upperEdge (  ) const = 0;
    
   virtual double value ( int index ) const = 0;
    
   virtual double weight ( int index ) const = 0;
    
   virtual double mean (  ) const = 0;
    
   virtual double rms  (  ) const = 0;
   
  //-ap should this be const ?
   virtual bool convert ( int nBins, double lowerEdge, double upperEdge ) = 0;
    
    /**     
     * @return the histogram. 
     * @throws RuntimeException if the histogram is not auto-convertible and "convert"
     * has not been called.
     */
   virtual IHistogram1D * histogram (  ) = 0;
};
#endif /* ifndef AIDA_ICLOUD1D_H */ 

