
// This file has been automatically converted from ITupleFactory.java 

#ifndef AIDA_ITUPLEFACTORY_H 
#define AIDA_ITUPLEFACTORY_H 1

/**
 * A factory for creating ITuples.
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ITupleFactory.h,v 1.5 2001/08/08 09:35:43 pfeiffer Exp $
 */

// includes 
#include <vector>
#include <string>

// type ahead declarations 
class ITuple;


class ITupleFactory  {

public:

   virtual ~ITupleFactory () { /* nop */; }

    /**
     * Create an NTuple
     * @param name The persistency name of the n-tuple
     * @param label The label of the n-tuple
     * @param columnNames The names of the columns
     * @param columnType The types of  the columns
     * @param options NTuple options (currently undefined)
     */
   virtual ITuple * create ( const std::string & name, const std::string & label, const std::vector< std::string > & columnNames, const std::vector< std::string > & columnType, const std::string & options = "" ) = 0;

    /**
     * Create an NTuple
     * @param name The persistency name of the n-tuple
     * @param label The label of the n-tuple
     * @param columns The names and types of the columns e.g. "float px, py, pz, float energy, int charge"
     * @param options NTuple options (currently undefined)
     */
   virtual ITuple * create ( const std::string & name, const std::string & label, const std::string & columns, const std::string & options = "" ) = 0;
};
#endif /* ifndef AIDA_ITUPLEFACTORY_H */ 

