
// This file has been automatically converted from ICloud.java 

#ifndef AIDA_ICLOUD_H 
#define AIDA_ICLOUD_H 1

/**
 * User level interface to a Cloud.
 * A Cloud is an unbinned collection of points. It can be used to
 * represent scatter plots or dynamically rebinnable histograms.
 * If they number of entries in the cloud exceeds some threshold 
 * they may be automatically converted to a binned histogram.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud.h,v 1.10 2001/11/29 07:38:44 barrand Exp $
 */

// base class(es)
#include "AIDA/IConstants.h"


class ICloud : virtual public IConstants {

public:

   virtual ~ICloud () { /* nop */; }

   virtual const std::string & label (  ) const = 0;
    
   virtual bool setLabel ( const std::string & label ) = 0;
    
   virtual int entries (  ) const = 0;
    
   virtual int dimension (  ) const = 0;
    
   virtual double sumOfWeights (  ) const = 0;

};
#endif /* ifndef AIDA_ICLOUD_H */ 

