
// This file has been automatically converted from ICloudFactory.java 

#ifndef AIDA_ICLOUDFACTORY_H 
#define AIDA_ICLOUDFACTORY_H 1

/**
 * A factory for creating clouds.
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloudFactory.h,v 1.5 2001/10/25 14:42:25 pfeiffer Exp $
 */

// includes 
#include <string>

// type ahead declarations 
class ICloud1D;
class ICloud2D;
class ICloud3D;


class ICloudFactory  {

public:

  virtual ~ICloudFactory () { /* nop */; }

  // nMax = -1 indicates no (user-specified) limit ...
  virtual ICloud1D * create1D ( const std::string & name, const std::string & label, int nMax = -1, const std::string & options = "") = 0;
  virtual ICloud1D * create1D ( const std::string & nameAndLabel ) = 0;                             
  
  // nMax = -1 indicates no (user-specified) limit ...
  virtual ICloud2D * create2D ( const std::string & name, const std::string & label, int nMax = -1, const std::string & options = "") = 0;
  virtual ICloud2D * create2D ( const std::string & nameAndLabel ) = 0;

  // nMax = -1 indicates no (user-specified) limit ...
  virtual ICloud3D * create3D ( const std::string & name, const std::string & label, int nMax = -1, const std::string & options = "") = 0;
  virtual ICloud3D * create3D ( const std::string & nameAndLabel ) = 0;
};
#endif /* ifndef AIDA_ICLOUDFACTORY_H */ 

