
#ifndef AIDA_IFILTERFACTORY_H 
#define AIDA_IFILTERFACTORY_H 1

/**
 * Creation of Filters
 * 
 * @author Guy Barrand
 */

// includes 
#include <string>

// type ahead declarations 
class ITuple;
class IFilter;

class IFilterFactory {
    
public:
  virtual ~IFilterFactory () { /* nop */; }

  /**
   * Create an evaluator that uses some interpreter.
   * @param ITuple : tuple to work with.
   * @param script : the script has the syntax of one C "within if" statement.
   *                 Variables are assumed to be labels of tuple columns.
   *                 Standard C math function are authorized.
   *                 for example "(A>1)&&(sin(B)<=0)"
   * @returns the requested filter.
   */
  virtual IFilter* createScripted(const ITuple&,
				  const std::string & script) = 0;

};

#endif /* AIDA_IFILTERFACTORY_H */
