#ifndef AIDA_IPLOTTERFACTORY_H 
#define AIDA_IPLOTTERFACTORY_H 1

/**
 * @author Guy Barrand
 * @version $Id: IPlotterFactory.h,v 1.1 2001/11/23 15:26:24 barrand Exp $
 */

// includes 
#include <string>

class IPlotter;

class IPlotterFactory  {

public:

   virtual ~IPlotterFactory () { /* nop */; }

   /** 
     * @param name. A string identifier. 
                    A plotter is in general managed by a GUI.
                    The "name" of the plotter could be used as 
                    the string identifier for the GUI plotter widget.
                    If "" is passed, some default plotter is used.
    */

   virtual IPlotter* create(const std::string & name = "") = 0;
};

#endif /* ifndef AIDA_IPLOTTERFACTORY_H */ 

