package hep.aida;

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud1D.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface ICloud1D extends ICloud {

    /**
     * @returns false if the cloud is full. You may convert it to a histogram.
     */
    public boolean fill(double x);
    
    public boolean fill(double x, double weight);
    
    public double lowerEdge();
    
    public double upperEdge();
    
    public double value(int index);
    
    public double weight(int index);
    
    public double mean();
    
    public double rms();
    
    public void convert(int nBins, double lowerEdge, double upperEdge);
    
    /**     
     * @return the histogram. 
     * @throws RuntimeException if the histogram is not auto-convertible and "convert"
     * has not been called.
     */
    public IHistogram1D histogram() throws RuntimeException;
}
