package hep.aida;

/**
 * User level interface to a 1D Cloud.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloud2D.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface ICloud2D extends ICloud {

    public boolean fill(double x, double y);
    
    public boolean fill(double x, double y, double weight);
    
    public double lowerEdgeX();
    
    public double lowerEdgeY();
    
    public double upperEdgeX();
    
    public double upperEdgeY();
    
    public double valueX(int index);
    public double valueY(int index);    
    public double weight(int index);
    
    public double meanX();
    
    public double meanY();
    
    public double rmsX();
    
    public double rmsY();
    
    public void convert(int nBinsX, double lowerEdgeX, double upperEdgeX, 
                        int nBinsY, double lowerEdgeY, double upperEdgeY);
    
    public IHistogram2D histogram()throws RuntimeException;
}
