package hep.aida;

/**
 * A factory for creating clouds.
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: ICloudFactory.java,v 1.2 2001/07/11 19:26:00 tonyj Exp $
 */
public interface ICloudFactory {

    public ICloud1D create1D(String nameAndLabel);

    public ICloud1D create1D(String name,
                             String label);
                                                              
    public ICloud1D create1D(String name,
                             String label,
                             int nMax,
                             String options);
                             

    public ICloud2D create2D(String nameAndLabel);

    public ICloud2D create2D(String name,
                             String label);
                                                              
    public ICloud2D create2D(String name,
                             String label,
                             int nMax,
                             String options);

                                 
    public ICloud3D create3D(String nameAndLabel);

    public ICloud3D create3D(String name,
                             String label);
                                                              
    public ICloud3D create3D(String name,
                             String label,
                             int nMax,
                             String options);       
}
