/*
 * IEvaluatorFactory.java
 *
 * Created on November 12, 2001.
 */

package hep.aida;

/**
 * @author AIDA Team
 * @version $Id: IEvaluatorFactory.java,v 1.1 2001/11/12 11:10:31 barrand Exp $ 
 */
public interface IEvaluatorFactory 
{
  /**
   * Create an evaluator that uses some interpreter.
   * @param ITuple : tuple to work with.
   * @param script : the script has the syntax of one C statement.
   *                 Variables are assumed to be labels of tuple columns.
   *                 Standard C math function are authorized.
   *                 for example "2*A*sin(B)"
   * @returns the requested evaluator.
   */
  public IEvaluator create(ITuple tuple,String script);
}

