/*
 * IFilterFactory.java
 *
 * Created on November 12, 2001.
 */

package hep.aida;

/**
 * @author AIDA Team
 * @version $Id: IFilterFactory.java,v 1.1 2001/11/12 11:10:31 barrand Exp $ 
 */
public interface IFilterFactory 
{
  /**
   * Create an evaluator that uses some interpreter.
   * @param ITuple : tuple to work with.
   * @param script : the script has the syntax of one C "within if" statement.
   *                 Variables are assumed to be labels of tuple columns.
   *                 Standard C math function are authorized.
   *                 for example "(A>1)&&(sin(B)<=0)"
   * @returns the requested filter.
   */
    public IFilter create(ITuple tuple,String script);
}

