package hep.aida;

/**
 * A fittable function.
 * 
 * @author Pavel Binko, Dino Ferrero Merlino, Wolfgang Hoschek
 * @author Tony Johnson, Andreas Pfeiffer, Mark Donszelmann, Guy Barrand
 * @version $Id: IFitFunction.java,v 1.3 2001/11/07 22:41:00 tonyj Exp $
 */
public interface IFitFunction extends IFunction {

    /**
     *
     */
    public void setFixed(String name, boolean state);
    
    /**
     * - NOTE you may pass Double.NEGATIVE_INFINITY or Double.POSITIVE_INFINITY
     */
    public void setBounds(String name, double lower, double upper);
    
    /**
     *
     */
    public void clearBounds(String name);
    
    /**
     *
     */
    public void setStepSize(String name, double step);
    
    /**
     *
     */
    public double error(String name);
    
    /**
     *
     */
    public double[] errors();
    
    /**
     *
     */
    public double chiSquare();
    /**
     *
     */
    public double degreeOfFreedom (  );

    //
    // Methods needed by fitter, but not by user
    //
    
    /**
     *
     */
    public void setErrors(double[] errors);
    
    /**
     *
     */
    public void setChiSquare(double chiSquare);    
    
    /**
     *
     */
    public boolean setDegreeOfFreedom ( double degreeOfFreedom );
   
    /**
     *
     */
    public boolean hasGradient();
    
    /**
     * FIXME: We need a Fitter expert here!
     */
    public double[] getGradient(double[] one, double[] orTwo);
    
  /**
   * @param histogram The histogram to fit to the function.
   * @returns Whether the fit converged or not.
   */
   public boolean fit(IHistogram histogram);
}
