%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                             %
%  Style file for preparing papers for the CHEP'01 Conference %
%  in Beijing. 
%  
%   Derived from CHEP 2000 style of Michele Michelotto        %
%                                                             %
%  Corresponds to the instructions by the organizing committee%
%  as distributed to the contributors.                        %
%                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\NeedsTeXFormat{LaTeX2e} 
\LoadClass{article}
\pagestyle{empty}
\textwidth 145mm
\setlength{\parindent}{1cm}
\parskip 0pt
\textheight=210mm
\oddsidemargin33mm\evensidemargin33mm
\hoffset-1in
\marginparsep 0pt

\def\section{\@startsection {section}{1}{\z@}{-2.5ex plus-1ex minus
    -.2ex}{2.3ex plus.2ex}{\reset@font\large\bfseries}}
\def\subsection{\@startsection{subsection}{2}{\z@}{-2.25ex plus-1ex
    minus-.2ex}{1.5ex plus.2ex}{\reset@font\normalsize
                                \bfseries}}
\def\subsubsection{\@startsection{subsubsection}{3}{\z@}{-2.25ex plus
 -1ex minus-.2ex}{1.5ex plus.2ex}{\reset@font\normalsize
                                \mdseries}}
% \def\@seccntformat#1{\hbox to 0pt{\hss\csname the#1\endcsname\quad}}


%
%  Dense lists
%
\def\@listI{%
            \leftmargin10mm%
            \labelsep5mm%
            \labelwidth\leftmargin
            \advance\labelwidth-\labelsep
            \parsep \z@
            \topsep 0\p@ \@plus\p@
            \itemsep 0\p@ \@plus1\p@}
\let\@listi\@listI
\@listi
\def\@listii {\leftmargin10mm%
              \labelsep   5mm%
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep    0\p@ \@plus\p@
              \parsep    \z@
              \itemsep   \z@ \@plus\p@}
\def\@listiii{\leftmargin10mm%
              \labelsep   5mm%
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep    0\p@ \@plus\p@
              \parsep    \z@
              \partopsep \z@ \@plus\p@
              \itemsep   \z@ \@plus\p@}
\def\@listiv {\leftmargin10mm%
              \labelsep   5mm%
              \labelwidth\leftmarginiv%
              \advance\labelwidth-\labelsep
              \topsep    0\p@ \@plus\p@
              \parsep    \z@
              \itemsep   \z@ \@plus\p@}
\def\@listv  {\leftmargin10mm%
              \labelsep   5mm%
              \labelwidth\leftmarginv
              \advance\labelwidth-\labelsep%
              \topsep    0\p@ \@plus\p@
              \parsep    \z@
              \itemsep   \z@ \@plus\p@}
\def\@listvi {\leftmargin10mm%
              \labelsep   5mm
              \labelwidth\leftmarginvi
              \advance\labelwidth{-\labelsep}%
              \topsep    0\p@ \@plus\p@
              \parsep    \z@
              \itemsep   \z@ \@plus\p@}
\endinput
